
#include <stm32f10x.h>              /* STM32F10x Library */


#include "w6100.h"						/* W5100 Register definition */
#include "w6100_init.h"
#include "SPI.h"
#include "socket.h"
#include "dns.h"
#ifndef DATA_BUF_SIZE
	#define DATA_BUF_SIZE			2048
#endif
#define AS_IPV4 2
#define AS_IPV6 23
#define AS_IPDUAL 11

char* msg_v4 = "IPv4 mode";
char* msg_v6 = "IPv6 mode";
char* msg_dual = "Dual IP mode";

int32_t loopback_udps(uint8_t sn, uint8_t* buf, uint16_t port, uint8_t loopback_mode);
int32_t loopback_tcps(uint8_t sn, uint8_t* buf, uint16_t port, uint8_t loopback_mode);
int32_t loopback_tcpc(uint8_t sn, uint8_t* buf, uint8_t* destip, uint16_t destport, uint8_t loopback_mode);
uint8_t buff[2048];
uint8_t buff0[2048];
uint8_t IP_TYPE;
u_char URL[] = "www.baidu.com";
//uint8_t dns_server_ip[4] = {168,126,63,1};
uint8_t dns_server_ip[4] = {8,8,8,8};
uint8_t dns_server_ip6[16] = {0x20,0x01,0x0d,0xa8,
								0x02,0x02,0x00,0x10,
								0x00,0x00,0x00,0x00,
								0x00,0x00,0x00,0x36
};
/******************************************************************************/
/*******************           Main function             **********************/
/******************************************************************************/
int main(void)
{
	uint8 server_ip[4]={192,168,1,11};			// Զ̷IPַ
	uint8 server_ip6[16]={0xfe, 0x80, 0x00, 0x00,
							0x00, 0x00, 0x00, 0x00,
							0x75, 0x03, 0x1b, 0x81,
							0xf3, 0xee, 0x0c, 0x4a};			// Զ̷IPַ
 
uint8_t dnsclient_ip[16] = {0,};
  /***** MCUʱӳʼ *****/							  
	Systick_Init(72);	
	
	TimerInit();
	/***** ڳʼ *****/
	USART1_Init(); 		
	printf("usart init ok\r\n");
	/***** GPIOSPIʼ *****/
	GPIO_Configuration();		
#if _WIZCHIP_IO_MODE_ & _WIZCHIP_IO_MODE_BUS_INDIR_	
	 FSMC_Init();
#else	
	WIZ_SPI_Init();	
#endif
	
	/*reset w6100*/
	Reset_W6100();
	
	/*w6100 net init*/
	Set_Network();														//
	/*ini DNS*/
	DNS_init(buff0);

	while(1)
    {

		if(GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_8)== Bit_RESET)
		{
			while(GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_8)== Bit_RESET);
				//IP_TYPE = 0x01;
				//printf("\r\n########## USer1 was released.IPv6\r\n");
				////while (DNS_run(0,dns_server_ip6,URL,dnsclient_ip,AS_IPV6) != 1);
				//printf("> Translated %s to %d.%d.%d.%d\r\n",URL,dnsclient_ip[0],dnsclient_ip[1],dnsclient_ip[2],dnsclient_ip[3]);

				IP_TYPE = 0x1c;
				while (DNS_run(0,dns_server_ip6,URL,dnsclient_ip,AS_IPV6) != 1);
				printf("> Translated %s to %.2x%.2x:%.2x%.2x:%.2x%.2x:%.2x%.2x:%.2x%.2x:%.2x%.2x:%.2x%.2x:%.2x%.2x\r\n",URL,dnsclient_ip[0],dnsclient_ip[1],dnsclient_ip[2],dnsclient_ip[3]
						,dnsclient_ip[4],dnsclient_ip[5],dnsclient_ip[6],dnsclient_ip[7]
						,dnsclient_ip[8],dnsclient_ip[9],dnsclient_ip[10],dnsclient_ip[11]
						,dnsclient_ip[12],dnsclient_ip[13],dnsclient_ip[14],dnsclient_ip[15]);

		}
		if(GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_1)== Bit_RESET)
		{

			while(GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_1)== Bit_RESET);
				IP_TYPE = 0x01;
				printf("\r\n########## USer0 was released. IPv4\r\n");
					while (DNS_run(1,dns_server_ip,URL,dnsclient_ip,AS_IPV4)  != 1);
				printf("> Translated %s to %d.%d.%d.%d\r\n",URL,dnsclient_ip[0],dnsclient_ip[1],dnsclient_ip[2],dnsclient_ip[3]);

				//IP_TYPE = 0x1c;
				//while (DNS_run(1,dns_server_ip,URL,dnsclient_ip,AS_IPV4)  != 1);
				//printf("> Translated %s to %.2x%.2x:%.2x%.2x:%.2x%.2x:%.2x%.2x:%.2x%.2x:%.2x%.2x:%.2x%.2x:%.2x%.2x\r\n",URL,dnsclient_ip[0],dnsclient_ip[1],dnsclient_ip[2],dnsclient_ip[3]
				//					,dnsclient_ip[4],dnsclient_ip[5],dnsclient_ip[6],dnsclient_ip[7]
				//					,dnsclient_ip[8],dnsclient_ip[9],dnsclient_ip[10],dnsclient_ip[11]
				//					,dnsclient_ip[12],dnsclient_ip[13],dnsclient_ip[14],dnsclient_ip[15]);
	   }
   }
	
}


