#ifndef __W6100_INIT_H
#define __W6100_INIT_H
#include <stdio.h>
#include <string.h>
#include <stdarg.h>

#include "types.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"
#include "w6100.h"
#define ON										1
#define OFF										0
#define HIGH									1
#define LOW										0

#define WIZ_CS_PORT     GPIOD
#define WIZ_SCS			    GPIO_Pin_7	// out

#define WIZ_SPI_PORT    GPIOB
#define WIZ_SCLK				GPIO_Pin_13	// out
#define WIZ_MISO				GPIO_Pin_14	// in
#define WIZ_MOSI				GPIO_Pin_15	// out

#define WIZ_RESET_PORT		GPIOD
#define WIZ_RESET		     GPIO_Pin_8	// out
//#define WIZ_INT			    GPIO_Pin_9	// in

void Systick_Init (uint8 SYSCLK);
void delay_s( uint32 time_s );
void delay_us(uint32 time_us);
void delay_ms(uint32 time_ms); 
void GPIO_Configuration(void);
void Set_Network(void);
void USART1_Init(void);
void Reset_W6100(void);
void FSMC_Init(void);
void  GPIO_Config(void);
void TimerInit(void);

uint16 ATOI(char* str,uint16 base); 			/* Convert a string to integer number */
uint32 ATOI32(char* str,uint16 base); 			/* Convert a string to integer number */
void itoa(uint16 n,uint8* str, uint8 len);
int ValidATOI(char* str, int base, int* ret); 		/* Verify character string and Convert it to (hexa-)decimal. */
char C2D(u_char c); 					/* Convert a character to HEX */

uint16 swaps(uint16 i);
uint32 swapl(uint32 l);

void replacetochar(char * str, char oldchar, char newchar);

void mid(int8* src, int8* s1, int8* s2, int8* sub);
void inet_addr_(unsigned char* addr,unsigned char *ip);

char* inet_ntoa(unsigned long addr);			/* Convert 32bit Address into Dotted Decimal Format */
char* inet_ntoa_pad(unsigned long addr);

//unsigned long inet_addr(unsigned char* addr);		/* Converts a string containing an (Ipv4) Internet Protocol decimal dotted address into a 32bit address */

char VerifyIPAddress_orig(char* src);			/* Verify dotted notation IP address string */
char VerifyIPAddress(char* src, uint8 * ip);
unsigned long GetDestAddr(SOCKET s);			/* Output destination IP address of appropriate channel */
unsigned int GetDestPort(SOCKET s);			/* Output destination port number of appropriate channel */
unsigned short htons( unsigned short hostshort);	/* htons function converts a unsigned short from host to TCP/IP network byte order (which is big-endian).*/
unsigned long htonl(unsigned long hostlong);		/* htonl function converts a unsigned long from host to TCP/IP network byte order (which is big-endian). */
unsigned long ntohs(unsigned short netshort);		/* ntohs function converts a unsigned short from TCP/IP network byte order to host byte order (which is little-endian on Intel processors). */
unsigned long ntohl(unsigned long netlong);		/* ntohl function converts a u_long from TCP/IP network order to host byte order (which is little-endian on Intel processors). */
u_char CheckDestInLocal(u_long destip);			/* Check Destination in local or remote */

SOCKET getSocket(unsigned char status, SOCKET start); 	/* Get handle of socket which status is same to 'status' */
unsigned short checksum(unsigned char * src, unsigned int len);		/* Calculate checksum of a stream */

#endif
